Description

Current implementation of Lazy#zip has problems:

1. calls lazy when this is not excepted, necessary nor documented. Any reason to not call each instead?

2. calls lazy without checking previously for type:

[1].lazy.zip(42) # =>NoMethodError: undefined method `lazy' for 42:Fixnum

expected same as [1].zip(42), i.e. a TypeError

3. inefficient in the case where all arguments are arrays

I'll address these when I get a chance. I don't understand why lazy is called instead of each though. Anyone?

Associated revisions

Revision 1af390b1ea11acd00558e8d86d23d17d328e580d - 01/24/2013 07:05 AM - Marc-Andre Lafortune 

enumerator.c: Optimize Lazy#zip when passed only arrays

[Bug #7706]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@38925 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 1af390b1 - 01/24/2013 07:05 AM - Marc-Andre Lafortune 

enumerator.c: Optimize Lazy#zip when passed only arrays

[Bug #7706]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@38925 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision aab2f788d784ef73dd088f7cc6e258672da0ae59 - 01/24/2013 07:50 AM - Marc-Andre Lafortune 

enumerator.c (lazy_zip): raise error for bad arguments
git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@38926 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision aab2f788 - 01/24/2013 07:50 AM - Marc-Andre Lafortune 

enumerator.c (lazy_zip): raise error for bad arguments
git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@38926 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 96af5360a4089daf90743ad4722e77eff2261145 - 01/24/2013 07:51 AM - Marc-Andre Lafortune 

enum.c (enum_zip): Fix error message

06/15/2025 1/2



array.c (take_items): Same, for Array#zip

[Bug #7706]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@38927 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 96af5360 - 01/24/2013 07:51 AM - Marc-Andre Lafortune 

enum.c (enum_zip): Fix error message

array.c (take_items): Same, for Array#zip
git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@38927 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 01/24/2013 04:05 PM - marcandre (Marc-Andre Lafortune)

- Status changed from Open to Closed

- % Done changed from 0 to 100

This issue was solved with changeset r38925.

Marc-Andre, thank you for reporting this issue.

Your contribution to Ruby is greatly appreciated.

May Ruby be with you.
